%error = forceRequiredAddon("Weapon_Pushbroom");
if(%error == $error::AddOn_Disabled)
{
	Pushbroomitem.uiName="";
}
if(%error == $error::AddOn_NotFound)
{
   error("Stupid yous! You deleted your pushbroom. No witchbroom for yous.");
   return;
}
datablock itemData(WitchBroomItem:PushBroomItem)
{
	shapeFile="./WitchbroomItem.dts";
	uiName="Witch Broom";
	image=witchBroomImage;
};
// Credit to badspot for code
datablock shapeBaseImageData(WitchBroomImage:PushBroomItem)
{
	shapeFile="./WitchbroomItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.7 1.2 -0.15";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = pushBroomItem;
   ammo = " ";
   projectile = pushBroomProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = pushBroomItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.0;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = true;
	stateTimeoutValue[2]            = 0.01;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Fire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = true;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateSequence[3]				= "Fire";
   stateTransitionOnTriggerUp[3]	= "StopFire";
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
   stateSound[4] = pushBroomSwingSound;

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";
};
function WitchBroomImage::onFire(%this,%player)
{
	parent::onFire(%this,%player);
	%player.broomify();
	serverCmdUnUseTool(%player.client);
}
function player::broomify(%this)
{
	%broom=new flyingVehicle() {
		datablock=WitchBroomVehicle;
		position=%this.getHackPosition();
		rotation=getWords(%this.getTransform(),3);
	};
	%broom.setTransform(%this.getTransform());
	%broom.mountObject(%this,0);
}

// Vehicle

datablock flyingVehicleData(WitchBroomVehicle)
{
	   //Tagged fields for mission editor
      category = "Vehicles";
      displayName = " ";
   //Shapebase Fields
      shapeFile   = "./WitchBroomVehicle.dts"; //"Add-Ons/Vehicle_Magic_Carpet/Carpet.dts";  //.dts File
      emap        = true;
      mass        = 30;
      drag        = 1.7;
      density     = 6;
      
      maxDamage = 100.00;
      destroyedLevel = 100.00;
      speedDamageScale = 1.04;
      collDamageThresholdVel = 20.0;
      collDamageMultiplier   = 0.02;

   //Tagged fields for mounting
      minMountDist = 3;   
      numMountPoints = 2;
      mountThread[0] = "root";
      mountThread[1] = "root";
      lookUpLimit = 0.75;
		lookDownLimit = 0.35;

   //Vehicle Fields:
      jetForce          = 500;
      jetEnergyDrain    = 8;
      minJetEnergy      = 1;

      massCenter        = "0 0 -1";
      //massBox           = "1 1 1";
      bodyRestitution   = 0.5;
      bodyFriction      = 0.5;
      //softImpactSound   = ; //AudioProfile
      //hardImpactSound   = ; //AudioProfile

      minImpactSpeed    = 25;
      softImpactSpeed   = 25;
      hardImpactSpeed   = 50;
      minRollSpeed      = 0;
      maxSteeringAngle  = 0.785;

      maxDrag        = 40;
      minDrag        = 50;
      integration    = 4;
      collisionTol   = 0.1;
      contactTol     = 0.1;

      cameraRoll     = false;
      cameraMaxDist  = 13;        
      cameraLag      = 0.0;
      cameraDecay    = 0.0;
      cameraOffset   = 2.5;
      cameraTilt     = 0.0;

      //dustEmitter       = ; //ParticleEmitterData
      triggerDustHeight = 3.0;
      dustHeight        = 1.0;

      numDmgEmitterAreas   = 0;
      
      damageEmitter[0] = vehicleBurnEmitter;
      damageEmitterOffset[0] = "0.0 0.0 0.0 ";
      damageLevelTolerance[0] = 0.99;

      damageEmitter[1] = vehicleBurnEmitter;
      damageEmitterOffset[1] = "0.0 0.0 0.0 ";
      damageLevelTolerance[1] = 1.0;

      //splashEmitter[0]        = ; //ParticleEmitterData

      splashFreqMod     = 300.0;
      splashVelEpsilon  = 0.50;

      splash = vehicleSplash;
      splashVelocity = 4.0;
      splashAngle = 67.0;
      splashFreqMod = 300.0;
      splashVelEpsilon = 0.60;
      bubbleEmitTime = 1.4;
      splashEmitter[0] = vehicleFoamDropletsEmitter;
      splashEmitter[1] = vehicleFoamEmitter;
      splashEmitter[2] = vehicleBubbleEmitter;
      mediumSplashSoundVelocity = 10.0;   
      hardSplashSoundVelocity = 20.0;   
      exitSplashSoundVelocity = 5.0;

      exitSplashSoundVelocity    = 2.0;
      softSplashSoundVelocity    = 1.0;
      mediumSplashSoundVelocity  = 2.0;
      hardSplashSoundVelocity    = 3.0;
      //exitingWater               = ;   //AudioProfile
      //impactWaterEasy            = ;   //AudioProfile
      //impactWaterMedium          = ;   //AudioProfile
      //impactWaterHard            = ;   //AudioProfile
      //waterWakeSound             = ;   //AudioProfile

      collDamageThresholdVel  = 20;
      collDamageMultiplier    = 0.05;

   //For Wrench Gui
      rideAble = true;
      paintable = true;
		
   //Flying vehicle fields
      //jetSound = ;      //AudioProfile
      //engineSound = ;   //AudioProfile

      maneuveringForce        = 2000;
      horizontalSurfaceForce  = 30;
      verticalSurfaceForce    = 10;
      autoInputDamping        = 0;
      steeringForce           = 500;
      steeringRollForce       = 200;
      rollForce               = 10;
      autoAngularForce        = 1000;
      rotationalDrag          = 20;
      autoLinearForce         = 0;
      maxAutoSpeed            = 1;
      hoverHeight             = 10.0;
      createHoverHeight       = 10.0;
	  
      //forwardJetEmitter    = ; //ParticleEmitterData
      //backwardJetEmitter   = ; //ParticleEmitterData
      //downJetEmitter       = ; //ParticleEmitterData
      //trailEmitter         = ; //ParticleEmitterData

      minTrailSpeed        = 1;
      vertThrustMultiple   = 2;
   
   //Tagged fields for damage
      initialExplosionProjectile = vehicleExplosionProjectile;
      initialExplosionOffset = 0;         //offset only uses a z value for now

      burnTime = 500;

      finalExplosionProjectile = vehicleFinalExplosionProjectile;
      finalExplosionOffset = 0.5;          //offset only uses a z value for now

      minRunOverSpeed    = 1;   //how fast you need to be going to run someone over (do damage)
      runOverDamageScale = 10;   //when you run over someone, speed * runoverdamagescale = damage amt
      runOverPushScale   = 1000; //how hard a person you're running over gets pushed
};
package broomunmount {
	function player::unMount(%this)
	{
		%veh = %this.getObjectMount();
		if(!isObject(%veh))
			return;
		if(%veh.getDatablock().getName()$="WitchBroomVehicle")
		{
			parent::unMount(%this);
			schedule(10,0,checkForBroomDelete,%veh,%this);
		}
		else
			parent::unMount(%this);
	}
};
activatePackage(broomUnmount);
function checkForBroomDelete(%broom,%dri)
{
	if(%broom.getMountedObject(0)==0 && %broom.getMountedObject(1)==0)
	{
		%dri.unMount();
		%broom.delete();
		serverCmdUseTool(%dri.client,0);
		%dri.mountImage(witchBroomImage,0);
	}
}